using System;
using System.Xml;
using System.Collections;
using System.Threading;
using com.lblabs.backend.csharp;
using com.lblabs.javatool.csharp;
using com.lblabs.xmltool.csharp;

using com.lblabs.xmltool;

namespace com.lblabs.xmltool.csharp
{
	/// <summary>
	/// Summary description for LBXMLOperator.
	/// </summary>
	public class CSharpLBXMLOperator
	{
		LBXMLOperatorInvoker lbXMLOperatorInvoker = new LBXMLOperatorInvoker();

		public CSharpLBXMLOperator()
		{
		}

		public bool appendNodeByParentTag(string xmlFile, string parentTag, string childTag, string childValue)
		{
			string insertResult;
			bool isRequestDone = false;
			insertResult = lbXMLOperatorInvoker.appendNodeByParentTag(xmlFile, parentTag, childTag, childValue);
			if (insertResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool appendNodeByParentTagAndParentSibling(string xmlFile, string parentTag, string parentSiblingTag, string parentSiblingValue, string childTag, string childValue)
		{
			string insertResult;
			bool isRequestDone = false;
			insertResult = lbXMLOperatorInvoker.appendNodeByParentTagAndParentSibling(xmlFile, parentTag, parentSiblingTag, parentSiblingValue, childTag, childValue);
			if (insertResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool appendNodeByParentTagParentValueAndParentSibling(String xmlFile, String parentTag, String parentValue, String parentSiblingTag, String childTag, String childValue) 
		{
			string insertResult;
			bool isRequestDone = false;
			insertResult = lbXMLOperatorInvoker.appendNodeByParentTagParentValueAndParentSibling(xmlFile, parentTag, parentValue, parentSiblingTag, childTag, childValue);
			if (insertResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool removeNodeByTagValue(string xmlFile, string tag, string tagValue)
		{
			string removeResult;
			bool isRequestDone = false;
			removeResult = lbXMLOperatorInvoker.removeNodeByTagValue(xmlFile, tag, tagValue);

			if (removeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool changeByValue(string xmlFile, string oldValue, string newValue)
		{
			string changeResult;
			bool isRequestDone = false;
			changeResult = lbXMLOperatorInvoker.changeByValue(xmlFile, oldValue, newValue);
			if (changeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool changeByTag(string xmlFile, string tag, string newValue)
		{
			string changeResult;
			bool isRequestDone = false;
			changeResult = lbXMLOperatorInvoker.changeByTag(xmlFile, tag, newValue);
			if (changeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool changeByTagNewValue(string xmlFile, string tag, string oldValue, string newValue)
		{
			string changeResult;
			bool isRequestDone = false;
			changeResult = lbXMLOperatorInvoker.changeByTagNewValue(xmlFile, tag, oldValue, newValue);
			if (changeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool changeByNoTagNewValue(string xmlFile, string tag, string no, string newValue)
		{
			string changeResult;
			bool isRequestDone = false;
			changeResult = lbXMLOperatorInvoker.changeByNoTagNewValue(xmlFile, tag, no, newValue);
			if (changeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool changeBySiblingTagNewValue(string xmlFile, string siblingTag, string siblingValue, string newValue)
		{
			string changeResult;
			bool isRequestDone = false;
			changeResult = lbXMLOperatorInvoker.changeBySiblingTagNewValue(xmlFile, siblingTag, siblingValue, newValue);
			if (changeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool changeBySiblingTagUpdateTagNewValue(string xmlFile, string siblingTag, string siblingValue, string updateTag, string newValue)
		{
			string changeResult;
			bool isRequestDone = false;
			changeResult = lbXMLOperatorInvoker.changeBySiblingTagUpdateTagNewValue(xmlFile, siblingTag, siblingValue, updateTag, newValue);
			if (changeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool changeByKeyTagKeyValueUpdateTagNewValue(string xmlFile, string keyTag, string keyValue, string updateTag, string newValue)
		{
			string changeResult;
			bool isRequestDone = false;
			changeResult = lbXMLOperatorInvoker.changeByKeyTagKeyValueUpdateTagNewValue(xmlFile, keyTag, keyValue, updateTag, newValue);
			if (changeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool changeByKeyTagKeyValueSiblingTagUpdateTagNewValue(string xmlFile, string keyTag, string keyValue, string siblingTag, string siblingValue, string updateTag, string newValue)
		{
			string changeResult;
			bool isRequestDone = false;
			changeResult = lbXMLOperatorInvoker.changeByKeyTagKeyValueSiblingTagUpdateTagNewValue(xmlFile, keyTag, keyValue, siblingTag, siblingValue, updateTag, newValue);
			if (changeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public bool changeByMultipleTagsAndWhere(string xmlFile, Hashtable keyTagHash, Hashtable keyValueHash)
		{
			string changeResult;
			bool isRequestDone = false;
			string keyTagHashStr = convertHashToHashStr(keyTagHash);
			string keyValueHashStr = convertHashToHashStr(keyValueHash);
			changeResult = lbXMLOperatorInvoker.changeByMultipleTagsAndWhere(xmlFile, keyTagHashStr, keyValueHashStr);
			if (changeResult.CompareTo("successful") == 0)
			{
				isRequestDone = true;
			}
			else
			{
				isRequestDone = false;
			}
			return isRequestDone;
		}

		public string selectByKeyTag(string xmlFile, string keyTag)
		{
			string selectedResult = null;
			selectedResult = lbXMLOperatorInvoker.selectByKeyTag(xmlFile, keyTag);
			return selectedResult;
		}

		public string selectByTagAndWhere(string xmlFile, string keyTag, string searchTag, string keyValue)
		{
			string selectedResult = null;
			selectedResult = lbXMLOperatorInvoker.selectByTagAndWhere(xmlFile, keyTag, searchTag, keyValue);
			return selectedResult;
		}

		public string selectByBelowTagAndWhere(string xmlFile, string belowKeyTag, string searchTag, string belowKeyValue)
		{
			string selectedResult = null;
			selectedResult = lbXMLOperatorInvoker.selectByBelowTagAndWhere(xmlFile, belowKeyTag, searchTag, belowKeyValue);
			return selectedResult;
		}

		public string selectByKeyTagBelowTagAndWhere(String xmlFile, String keyTag, String keyValue, String belowTag, String belowValue, String searchTag)
		{
			string selectedResult = null;
			selectedResult = lbXMLOperatorInvoker.selectByKeyTagBelowTagAndWhere(xmlFile, keyTag, keyValue, belowTag, belowValue, searchTag);
			return selectedResult;
		}

		public Hashtable selectHash(string xmlFile, string hashTag)
		{
			Hashtable selectedResultHash = new Hashtable();
			string selectedResult = null;
			selectedResult = lbXMLOperatorInvoker.selectHash(xmlFile, hashTag);
			selectedResultHash = convertStringToHash(selectedResult);
			return selectedResultHash;
		}

		public Hashtable selectSet(string xmlFile, string setTag)
		{
			Hashtable selectedResultHash = new Hashtable();
			string selectedResult = null;
			selectedResult = lbXMLOperatorInvoker.selectSet(xmlFile, setTag);
			selectedResultHash = convertStringToHash(selectedResult);
			return selectedResultHash;
		}

		public string selectByMultipleTagsAndWhere(string xmlFile, Hashtable keyTagHash, Hashtable keyValueHash)
		{
			string selectedResult = null;
			string keyTagHashStr = convertHashToHashStr(keyTagHash);
			string keyValueHashStr = convertHashToHashStr(keyValueHash);
			selectedResult = lbXMLOperatorInvoker.selectByMultipleTagsAndWhere(xmlFile, keyTagHashStr, keyValueHashStr);
			return selectedResult;
		}

		public Hashtable selectByTagAndWhereForHash(string xmlFile, string keyTag, string searchTag, string keyValue)
		{
			Hashtable selectedResultHash = new Hashtable();
			string selectedResult = null;
			selectedResult = lbXMLOperatorInvoker.selectByTagAndWhereForHash(xmlFile, keyTag, searchTag, keyValue);
			selectedResultHash = convertStringToHash(selectedResult);
			return selectedResultHash;
		}

		public Hashtable selectByTagAndWhereForSet(string xmlFile, string keyTag, string searchTag, string keyValue)
		{
			Hashtable selectedResultHash = new Hashtable();
			string selectedResult = null;
			selectedResult = lbXMLOperatorInvoker.selectByTagAndWhereForSet(xmlFile, keyTag, searchTag, keyValue);
			selectedResultHash = convertStringToHash(selectedResult);
			return selectedResultHash;
		}

		public Hashtable selectByMultipleTagsAndWhereForHash(string xmlFile, Hashtable keyTagHash, Hashtable keyValueHash)
		{
			Hashtable selectedResultHash = new Hashtable();
			string selectedResult = null;
			string keyTagHashStr = convertHashToHashStr(keyTagHash);
			string keyValueHashStr = convertHashToHashStr(keyValueHash);
			selectedResult = lbXMLOperatorInvoker.selectByMultipleTagsAndWhereForHash(xmlFile, keyTagHashStr, keyValueHashStr);
			selectedResultHash = convertStringToHash(selectedResult);
			return selectedResultHash;
		}

		public Hashtable selectByMultipleTagsAndWhereForSet(string xmlFile, Hashtable keyTagHash, Hashtable keyValueHash)
		{
			Hashtable selectedResultHash = new Hashtable();
			string selectedResult = null;
			string keyTagHashStr = convertHashToHashStr(keyTagHash);
			string keyValueHashStr = convertHashToHashStr(keyValueHash);
			selectedResult = lbXMLOperatorInvoker.selectByMultipleTagsAndWhereForSet(xmlFile, keyTagHashStr, keyValueHashStr);
			selectedResultHash = convertStringToHash(selectedResult);
			return selectedResultHash;
		}

		private Hashtable convertStringToHash(string sourceString)
		{
			Hashtable finalHash = new Hashtable();
			string sourceValue;
			int index = sourceString.IndexOf("|");
			int i = 0;
			while (index >= 0)
			{
				sourceValue = sourceString.Substring(0, index);
				sourceString = sourceString.Substring(index + 1);
				finalHash.Add(i ++ , sourceValue);
				index = sourceString.IndexOf("|");
			}
			return finalHash;
		}

		private string convertHashToHashStr(Hashtable valueHash)
		{
			CSharpHashtablePlus hashtablePlus = new CSharpHashtablePlus();
			int hashSize = hashtablePlus.GetHashSize(valueHash);
			String valueStr = "";
			String singleStr;
			for (int i = 0; i < hashSize; i ++)
			{
				singleStr = (string)hashtablePlus.GetHashValue(valueHash, i);
				valueStr = valueStr + singleStr + "|";
			}
			return valueStr;
		}
	}
}
