using System;
using System.Xml;
using System.Xml.XPath;
using System.Collections;

namespace com.lblabs.backend.csharp
{
	/// <summary>
	/// Summary description for SystemConfig.
	/// </summary>
	public class CSharpSystemConfig
	{
		string sysConfigXML;

		public CSharpSystemConfig(string sysPath)
		{
			sysConfigXML = sysPath;
		}

		public string GetSysConfig(string configName)
		{
			string sysRoot = GetSubSysConfig("SystemRoot");
			string subSysConfig = GetSubSysConfig(configName);
			string sysConfig = sysRoot + subSysConfig;
			return sysConfig;
		}

		private string GetSubSysConfig(string configName)
		{
			string resultStr;
			XPathDocument xpDoc = new XPathDocument(sysConfigXML);
			XPathNavigator xpNav = xpDoc.CreateNavigator();

			XmlNamespaceManager xmlNM = new XmlNamespaceManager(xpNav.NameTable);
			xmlNM.AddNamespace("changmei","http://www.lblabs.com/namespace");

			XPathExpression xpEx = xpNav.Compile("/SystemConfig/Config");
			xpEx.SetContext(xmlNM);
			xpEx.AddSort("ConfigName",XmlSortOrder.Ascending,XmlCaseOrder.None,"",XmlDataType.Text);
			
			XPathNodeIterator xIter = xpNav.Select(xpEx);

			Hashtable resultHash = new Hashtable();

			while (xIter.MoveNext())
			{
				XPathNodeIterator xIterConfigName = xIter.Current.Select("ConfigName");
				xIterConfigName.MoveNext();
				XPathNodeIterator xIterPath = xIter.Current.Select("Path");
				xIterPath.MoveNext();
				XPathNodeIterator xIterFile = xIter.Current.Select("File");
				xIterFile.MoveNext();
				resultHash.Add(xIterConfigName.Current.Value, xIterPath.Current.Value + xIterFile.Current.Value);
			}
			resultStr = (string)GetHashValue(resultHash, configName);
			return resultStr;
		}

		private static object GetHashValue(Hashtable myHash, object index)
		{
			IDictionaryEnumerator myEnumerator = myHash.GetEnumerator();
			while ( myEnumerator.MoveNext() )
			{
				if (myEnumerator.Key.Equals(index))
				{
					return myEnumerator.Value;
				}
			}
			return null;
		}
	}
}
